unit penwidthunit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, davArrayBtn, StdCtrls, Buttons;

type
  Tpenwidthform = class(TForm)
    penwidthBtn: TDavArrayBtn;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure penwidthBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure penwidthBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function selectPenWidth(var w : byte) : boolean;

var
  penwidthform: Tpenwidthform;

implementation

uses Unit1;

{$R *.dfm}

var selectedbtn : byte;

function selectPenWidth(var w : byte) : boolean;
var i : byte;
    x,y : integer;
begin
 with form1 do
  begin
   x := left + propbtn.left + propbtn.width + 10;
   y := top + propbtn.top + 10;
  end;
 with penwidthform do
  begin
   left := x;
   top := y;
   if (w > 0) and (w <= 6) then
    begin
     penwidthbtn.BtnDown(w-1);
     selectedbtn := w-1;
    end
   else
    begin
     for i := 0 to 5 do penwidthbtn.btnrelease(i);
     selectedbtn := 10;
    end;
  end;
  penwidthform.ShowModal;
  result := (penwidthform.modalresult = mrOK) and (selectedBtn > 0)
                                              and (selectedBtn < 6);
  if result then w := selectedbtn + 1;
end;

procedure Tpenwidthform.penwidthBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 if status = stDown then
  begin
   selectedbtn := btnNr;
   modalresult := mrOK;
  end;
end;

procedure Tpenwidthform.penwidthBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
var x1,x2,y : integer;
    r : Trect;
begin
 with penwidthbtn do with canvas do
  begin
   r := getBtnRect(btnNr);
   x1 := r.left + 5;
   x2 := r.right - 5;
   y := r.top + btnHeight div 2;
   pen.width := btnNr + 1;
   pen.color := $000000;
   moveto(x1,y);
   lineto(x2,y);
  end;
end;

end.
